package CSVTalken;

#CSVInputStream(String $filename);
sub CSVInputStream{
	undef(@str);
	my $file=@_[0];
	my $x;
	$FILENAME=$file;
	open(FH,"$file") or CSVFileException("<h2>㳰InputStreamФ</h2>");
	$x=0;
	while(<FH>){
		$_=~tr/\x0D\x0A//d;
		#chop($_);
		$conv=$_;
		&jcode'convert(*conv,'euc');
		@str[$x]=$conv;
		$x++;
	}
	close(FH);
	return @str;
}
#CSVselectFrom(String $filename,int $celNum,String $words);
sub CSVselectFrom{
	my $file=@_[0];
	my $cell=@_[1];
	my $much=@_[2];
	my $x;
	my @gotdata;
	my @result;
	undef(@result);
	my $data;
	$FILENAME=$file;
	open(FH,"$file") or CSVFileException("<h2>㳰InputStreamФ</h2>");
	$x=0;
	while(<FH>){
		$_=~tr/\x0D\x0A//d;
		$conv=$_;
		&jcode'convert(*conv,'euc');
		@str[$x]=$conv;
		$x++;
	}
	close(FH);
	foreach $val(@str){
		undef(@gotdata);
		@gotdata=split(/\,/,$val);
		if(@gotdata[$cell] eq $much){
			$data=$val;
			push(@result,$data);
		}
	}
	return @result;
}
#CSVgetCelData(String $filename,String $id,int $IDcel,int $celNum);
sub CSVgetCelData{
	my $file=@_[0];
	my $id=@_[1];
	my $idcel=@_[2];
	my $cell=@_[3];
	my $x;
	my @gotdata;
	my $data;
	my $result;
	$FILENAME=$file;
	open(FH,"$file") or CSVFileException("<h2>㳰InputStreamФ</h2>");
	$x=0;
	while(<FH>){
		$_=~tr/\x0D\x0A//d;
		$conv=$_;
		&jcode'convert(*conv,'euc');
		@str[$x]=$conv;
		$x++;
	}
	close(FH);
	foreach $val(@str){
		undef(@gotdata);
		@gotdata=split(/\,/,$val);
		if(@gotdata[$idcel] eq $id){ $data=$val; }
	}
	undef(@gotdata);
	@gotdata=split(/\,/,$data);
	$result=@gotdata[$cell];
	return $result;
}
#CSVgetNumRows(String $filename,String words,int $celNum);
sub CSVgetNumRows{
	my $file=@_[0];
	my $id=@_[1];
	my $idcel=@_[2];
	my $x;
	my @gotdata;
	my $data;
	my $result=0;
	$FILENAME=$file;
	open(FH,"$file") or CSVFileException("<h2>㳰InputStreamФ</h2>");
	$x=0;
	while(<FH>){
		$_=~tr/\x0D\x0A//d;
		$conv=$_;
		&jcode'convert(*conv,'euc');
		@str[$x]=$conv;
		$x++;
	}
	close(FH);
	foreach $val(@str){
		undef(@gotdata);
		@gotdata=split(/\,/,$val);
		if(@gotdata[$idcel] eq $id){
			$data=$val;
			$result++;
		}
	}
	
	return $result;
}

#CSVgetAllNumRows(String $filename,String words,int $celNum);
sub CSVgetAllNumRows{
	my $file=@_[0];
	open(FH,"$file") or CSVFileException("<h2>㳰InputStreamФ</h2>");
	$x=0;
	while(<FH>){
		$_=~tr/\x0D\x0A//d;
		$x++;
	}
	return $x;
}

#CSVOutputStream(String $filename,String $newlinestr);
sub CSVOutputStream{
	my $file=@_[0];
	my $strNewLine=@_[1];
	$FILENAME=$file;
	undef(@fileData);
	@fileData=&CSVInputStream($file);
	open(FH,">$file") or CSVFileOutputException("<h2>㳰OutputStreamФ</h2>");
	flock(FH,2);
	unshift(@fileData,$strNewLine);
	foreach $val(@fileData){
		$val.="\n";
		print FH $val;
	}
	flock(FH,8);
	close(FH);
}



#CSVOverWriteStream(String $filename,String $newlinestr,int $oldline);
sub CSVOverWriteStream{
	my $file=@_[0];
	my $strNewLine=@_[1];
	my $line=@_[2];
	$FILENAME=$file;
	@fileData=&CSVInputStream($file);
	open(FH,">$file") or CSVFileOutputException("<h2>㳰OutputStreamФ</h2>");
	flock(FH,2);
	splice(@fileData,$line,1);
	unshift(@fileData,$strNewLine);
	my $alength=@fileData;
	#if($alength>50){ pop(@fileData); }
	foreach $val(@fileData){
		$val.="\n";
		print FH $val;
	}
	flock(FH,8);
	close(FH);
}
#CSVOverWriteOutputStream(String $filename,String $newlinestr,String $oldid,int $celNum);
sub CSVOverWriteOutputStream{
	my $file=@_[0];
	my $strNewLine=@_[1];
	my $oldID=@_[2];
	my $celLine=@_[3];
	my @oneLine;
	$FILENAME=$file;
	undef(@fileData);
	@fileData=&CSVInputStream($file);
	open(FH,">$file") or CSVFileOutputException("<h2>㳰OutputStreamФ</h2>");
	flock(FH,2);
	undef($val);
	my $lines=@fileData;
	my $x=0;
	my $searchflag='false';
	for($x=0;$x<$lines;$x++){
		undef(@oneLine);
		@oneLine=split(/\,/,@fileData[$x]);
		if($oldID eq @oneLine[$celLine]){
			$searchflag='true';
			last;
		}
	}
	if($searchflag eq 'false'){ &CSVFileOutputException("<h2>㳰ɣĤʤ</h2>"); }
	splice(@fileData,$x,1);
	unshift(@fileData,$strNewLine);
	#@fileData[$x]=$strNewLine;
	undef($val);
	foreach $val(@fileData){
		$val.="\n";
		print FH $val;
	}
	flock(FH,8);
	close(FH);
}



#CSVDeleteLine(String $filename,String $id,int $daleteline);
sub CSVDeleteLine{
	my $file=@_[0];
	my $oldID=@_[1];
	my $celLine=@_[2];
	my @oneLine;
	$FILENAME=$file;
	undef(@fileData);
	@fileData=&CSVInputStream($file);
	open(FH,">$file") or CSVFileOutputException("<h2>㳰CSVDeleteLineФ</h2>");
	flock(FH,2);
	undef($val);
	my $lines=@fileData;
	my $x=0;
	my $searchflag='false';
	for($x=0;$x<$lines;$x++){
		undef(@oneLine);
		@oneLine=split(/\,/,@fileData[$x]);
		if($oldID eq @oneLine[$celLine]){
			$searchflag='true';
			last;
		}
	}
	if($searchflag eq 'false'){ &CSVFileOutputException("<h2>㳰ɣĤʤ</h2>"); }
	splice(@fileData,$x,1);
	foreach $val(@fileData){
		$val.="\n";
		print FH $val;
	}
	flock(FH,8);
	close(FH);
}
#CSVCreateNewLine(String $str);
sub CSVCreateNewLine{
	undef($newLine);
	foreach $val(@_){
		$newLine.=$val.',';
	}
	return $newLine;
}
sub CSVFileOutputException{
	flock(FH,8);
	close(FH);
	open(FH,">$FILENAME") or CSVFileException("<h2>㳰OutputStreamФ</h2>");
	flock(FH,2);
	foreach $val(@fileData){
		$val.="\n";
		print FH $val;
	}
	flock(FH,8);
	close(FH);
	print "Content-type: text/html\n\n";
	print "<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n";
	print "<title>㳰ȯCSV顼</title></head><body>\n";
	print "$_[0]";
	print "</body></html>";
	exit;
}
sub CSVFileException{
	print "Content-type: text/html\n\n";
	print "<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n";
	print "<title>㳰ȯCSV顼</title></head><body>\n";
	print "$_[0]";
	print "</body></html>";
	exit;
}
1;
